"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const WebServer_1 = require("./WebServer");
const Home_1 = require("./impl/Home");
const Static_1 = require("./impl/Static");
const Actuator_1 = require("./impl/Actuator");
const Stdout_1 = require("./impl/Stdout");
class Dashboard extends WebServer_1.WebServer {
    getRoutes() {
        return [Stdout_1.Stdout, Actuator_1.Actuator, Static_1.Static, Home_1.Home];
    }
    getPort() {
        const port = process.env.DASHBOARD_PORT ? Number(process.env.DASHBOARD_PORT) : 9081;
        const host = process.env.DASHBOARD_HOST || '127.0.0.1';
        return { port, host };
    }
    start() {
        const _super = name => super[name];
        return __awaiter(this, void 0, void 0, function* () {
            yield _super("start").call(this);
            const { port, host } = this.getPort();
            console.log(`Pandora.js Dashboard started, open http://${host}:${port}/`);
            this.echoTestErrors().catch(console.error);
        });
    }
    echoTestErrors() {
        return __awaiter(this, void 0, void 0, function* () {
            for (let idx = 0; idx < 100; idx++) {
                yield new Promise(resolve => {
                    setTimeout(resolve, 200);
                });
                console.error(new Error('Test Errror ' + (idx + 1)));
            }
        });
    }
}
exports.default = Dashboard;
//# sourceMappingURL=Dashboard.js.map