"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const urllib = require("urllib");
const Common_1 = require("../utils/Common");
const { GlobalConfigProcessor } = require('dorapan');
const globalConfig = GlobalConfigProcessor.getInstance().getAllProperties();
const actuatorPort = globalConfig.actuator.http.port;
class Actuator {
    constructor(app) {
        this.app = app;
    }
    get(ctx) {
        return __awaiter(this, void 0, void 0, function* () {
            const url = /^\/actuator(.*)/.exec(ctx.request.url)[1];
            ctx.body = yield Actuator.get(url);
        });
    }
    static get(url) {
        return __awaiter(this, void 0, void 0, function* () {
            const remoteUrl = 'http://127.0.0.1:' + actuatorPort + url;
            const res = yield urllib.request(remoteUrl, {
                timeout: 5000,
                dataType: 'json'
            });
            if (/^\/process/.test(url) && res.data.success && res.data.data) {
                yield Common_1.attachPPID(res.data.data);
            }
            return res.data;
        });
    }
}
Actuator.route = '/actuator/*';
exports.Actuator = Actuator;
//# sourceMappingURL=Actuator.js.map