"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const cp = require("mz/child_process");
function attachPPID(processes) {
    return __awaiter(this, void 0, void 0, function* () {
        const relations = yield getPPIDRelations();
        for (const process of processes) {
            if (!process.ppid) {
                process.ppid = relations.get(Number(process.pid));
            }
        }
        return processes;
    });
}
exports.attachPPID = attachPPID;
function getPPIDRelations() {
    return __awaiter(this, void 0, void 0, function* () {
        const stdout = yield cp.exec('ps -A -o pid,ppid');
        const ps = stdout.toString().split('\n');
        // get rid of the header
        ps.shift();
        // get rid of the last empty line
        ps.pop();
        const relations = new Map;
        ps.forEach(line => {
            line = line.trim();
            const matches = line.match(/^(\d+)\s+(\d+)/);
            matches.shift();
            const [pid, ppid] = matches;
            relations.set(Number(pid), Number(ppid));
        });
        return relations;
    });
}
exports.getPPIDRelations = getPPIDRelations;
//# sourceMappingURL=Common.js.map